<?php

namespace AppBundle\Controller;

use AppBundle\Domain\Users\User;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;

/**
 * Class RegisterUserController.
 */
class RegisterUserController extends Controller
{
    /**
     * @Route("/signin", name="register_user")
     */
    public function indexAction()
    {
        $userSession = $this->get('app.controller_session.user_session');

        if ($userSession->isLogged()) {
            return $this->redirectToRoute('admin_dashboard');
        }

        $user = User::createFormEntity();
        $user->setRepassword('');

        $form = $this->createFormBuilder(User::createFormEntity())
            ->add('email', 'text')
            ->add('password', 'password')
            ->add('repassword', 'password', ['label' => 'Retype the password'])
            ->add('save', 'submit', ['label' => 'Sign In'])
            ->setAction($this->generateUrl('register_user_submit'))
            ->getForm();

        return $this->render(
            'default/registeruser.html.twig',
            ['form' => $form->createView(), 'userSession' => $userSession]
        );
    }
}
